// =========================================================================
//
// RA2TBBS.C -- Convert RA User file to TBBS user file
//
// Copyright (c) 1995, 1996 by Robert Dyball, bob.dyball@dse.com.au
//
// -------------------------------------------------------------------------
//
// History:  version    Notes:
//
// 01-01-95  0.1 	Started user conversion utility
//
//
// 07-02-96  0.9        Rearranged flags, all now in A1-8 flag set
//			put RAPWD CRC on end of notes field instead of start,
//                      added gender (MF?) and date of birth to TBBS notes
//
// 14-02-96  0.92       set up levels for sysops to 0 for no limits, and
//                      set import for RA comments to TBBS notes field.
//
// 24-10-96  ----       added some more comments and a bit of documentation
//
// =========================================================================

#include <stdlib.h>
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <io.h>
#include <time.h>
#include "ra200.h"
#include "tbbs_2.h"

USERS    users;
USERLOG	tusers;
RACONF config;

char states[8][4]={"NT\0","ACT\0","NSW\0","VIC\0","QLD\0","SA\0","WA\0","TAS\0"};

char password[20];


// -------------------------------------------------------------------------
// procedure to allow displaying users from RA user base.
// -------------------------------------------------------------------------


void d_rauser(void)
{

int i;
char j;


/* i = sizeof(users); */
/*   printf ("%i\n", i); */
/*   printf("Size of name field:     %hd\n", j); */

   printf("Name: %.*hs\n", users.name.l1, users.name.string);
   printf("Hndl: %.*hs\n", users.l6,      users.handle);
   printf("Locn: %.*hs\n", users.l1,      users.location);
   printf("Orgn: %.*hs\n", users.l2,      users.organization);
   printf("Add1: %.*hs\n", users.l3,      users.address1);
   printf("Add2: %.*hs\n", users.l4,      users.address2);
   printf("Add3: %.*hs\n", users.l5,      users.address3);
   printf("Cmnt: %.*hs\n", users.l7,      users.comment);
   printf("Pswd: %ld\n",   users.passwordcrc);
   printf("DPhn: %.*hs\n", users.l8,      users.dataphone);
   printf("VPhn: %.*hs\n", users.l9,      users.voicephone);
   printf("LTim: %.*hs\n", users.lasttime.l1, users.lasttime.Time);
   printf("LDat: %.*hs\n", users.lastdate.l1, users.lastdate.Date);
   printf("Atr1: %hd\n", users.attribute);
   printf("Atr2: %hd\n", users.Attribute2);
   printf("Flgs: %ld\n", users.flags);
   printf("Crdt: %ld\n", users.credit);
   printf("Pndg: %ld\n", users.pending);
   printf("MsgP: %d\n", users.msgsposted);
   printf("Scty: %d\n", users.security);
   printf("lstr: %ld\n", users.lastread);
   printf("nocl: %ld\n", users.nocalls);
   printf("UL's: %ld\n", users.uploads);
   printf("DL's: %ld\n", users.downloads);
   printf("UL_k: %ld\n", users.uploadsk);
   printf("DL_k: %ld\n", users.downloadsk);
   printf("TdyK: %ld\n", users.todayk);
   printf("Elps: %ld\n", users.elapsed);
   printf("ScLn: %ld\n", users.screenlength);
   printf("LPwC: %hd\n", users.lastpwdchange);
   printf("Grp : %ld\n", users.group);
/*      COMBINED        combinedinfo; */
   printf("FDat: %.*hs\n",	users.firstdate.l1,	users.firstdate.Date);
   printf("BDat: %.*hs\n",	users.birthdate.l1,	users.birthdate.Date);
   printf("SDat: %.*hs\n",	users.subdate.l1, 	users.subdate.Date);
   printf("ScWd: %hd\n",	users.screenwidth);
   printf("Lang: %hd\n",	users.language);
   printf("DFmt: %hd\n", 	users.dateformat);
   printf("Fwd2: %.*hs\n",	users.l10, 			users.forwardto);
   printf("MsgA: %d\n",		users.msgarea);
   printf("FilA: %d\n",		users.filearea);
   printf("Prot: %c\n",		users.defaultprot);
   printf("FilG: %d\n",		users.filegroup);
   printf("DOBC: %hd\n",	users.lastdobcheck);
   printf("Sex : %hd\n",	users.sex);
   printf("XIrc: %ld\n",	users.XIrecord);
   printf("MsgG: %d\n",		users.msggroup);
/* printf("Free: %48c\n",	users.freespace); */

};

// -------------------------------------------------------------------------
// procedure to display users recorsd as they are converted, ready to go to
// TBBS userbase
// -------------------------------------------------------------------------


void d_tbbsuser(void)
{
   printf("Name: %s\n",  tusers.name_locn);
   printf("Pwd : %-8c\n", tusers.password);
};



// =========================================================================
// Procedure to map users from RA to TBBS userbase
// -------------------------------------------------------------------------
//
// NOTE: you will need to customise this section, as the stuff here has been
//       written to coincide with user levels and flag settings that I use,
//       these will not, inall likelihood, be much use to you, as yours will
//       be different...
//
// =========================================================================


void map_RA2TBBS(void)
{

int i,j,  flag0;
char ADDR1[50], ADDR2[50], CITY[30], STATE[5], ZIP[6], PHONE[15], COUNTRY[20];
char t[150], *x, tempnote[80];
char *blanks = "                                                                ";
long int *p;


/* 0-49 :  write username then location into bytes 0-49, with \0 between */

	strncpy(tusers.name_locn, strupr(users.name.string), users.name.l1);
	tusers.name_locn[users.name.l1] = '\0';

	j=min(50-users.name.l1,users.l1);

	i=-1;
	do {
		i=i+1;
		tusers.name_locn[users.name.l1+i+1]=users.location[i]; }
	while (i<j);

	i=min(50,users.name.l1+users.l1);
	do {
		i=i+1;
		tusers.name_locn[i]='\0';
	} while (i<50);

/* 50   : User's Password	 	*/
/*			RA   uses 32 bit CRC, non-text.								*/
/*			TBBS uses 8 byte pwd, text, space filled, left justified    */

i=-1;
do {
	i = i+1;
	tusers.password[i] = 32;
} while (i<=7);


/* 58   : User's security level into offset 58 (1 byte)                 */
/*		  RA   uses 2bytes 0-65535                                      */
/*		  TBBS uses 1 byte 0-255										*/

if (users.security > 255)

	tusers.userspriv = 255;

else

	tusers.userspriv = users.security;


/* 59   : User's A1 flags  (1 byte)											*/



//***************************************************************************
//
// The commented section (below) shows how I have used the flags from RA,
// and how I ended up using them on TBBS, since the changeover provided a
// good time to drop unused flags in RA and rethink how things were to be
// set up on the new TBBS system
//
//***************************************************************************




/* ================================+======================================= */
/* RA 							   |   	TBBS (A1(1)-(8))                    */
/* ---------------------+----------+-----------+--------------------------- */
/* If Flag ON    	|Flag OFF  |If Flag ON | IF Flag OFF                */
/* ---------------------+----------+-----------+--------------------------- */
/* A1 New User ANSI Chk |do ANSI ck| ignored   |Do ANSI and New User QALs   */
/* A2 RA Password convrt|cvt Passwd| ignored   |               		    */
/* A3 Internet Access 	|no access | access ON |No Internet email (RA C1)   */
/* A4 Staff Area Access |not staff |Staff OK   |Disabled  (from RA A4)      */
/* A5 Virus info access |no Virus  |CRIS/Nuke +|Disabled  (from RA B6)	    */
/* A6 UCCN access       |no UCCN   |UCCN Access|Disabled  (from RA B8)      */
/* A7 Over 18 y/o   	|< 18 y/o  | >= 18 y/o |Disabled                    */
/* A8 Expired User      | off      | on        |Disabled                    */
/* =====================+==========+===========+=========================== */

	tusers.A1 =   128 * 0
		     + 64 * 0
		     + 32 * ((users.flags[2] & 1))
		     + 16 * ((users.flags[0] & 8)/8)
		     +  8 * ((users.flags[1] & 32)/32)
		     +  4 * ((users.flags[0] & 128)/128)
		     +  2 * 0
		     +  1 * 0;

/* 60   : User's A2 flags  (1 byte)										*/
/*																		*/
/* ================================+======================================= */
/* RA 							   |   	TBBS (A2(1)-(8))                    */
/* ---------------------+----------+-----------+--------------------------- */
/* If Flag ON    	|Flag OFF  |If Flag ON | IF Flag OFF                */
/* ---------------------+----------+-----------+--------------------------- */
/* B1          		|          |           |                            */
/* B2			|	   |           |                            */
/* B3                 	|          |           |                            */
/* B4                   |          |           |                            */
/* B5                   |          |           |                            */
/* B6                  	|          |           |                            */
/* B7                   |          |           |                            */
/* B8                   |          |           |                            */
/* =====================+==========+===========+=========================== */


	tusers.A2 =   0;

/* ================================+======================================= */

/* ---------------------+----------+-----------+--------------------------- */
/* If Flag ON    	|Flag OFF  |If Flag ON | IF Flag OFF                */
/* ---------------------+----------+-----------+--------------------------- */
/* C1                   |          |           |                            */
/* C2			|	   |	       |			    */
/* C3                 	|          |	       |			    */
/* C4                   |          |	       |			    */
/* C5                   |          |	       |			    */
/* C6			|	   |	       |			    */
/* C7			|	   |	       |			    */
/* C8                	|	   |	       |			    */
/* =====================+==========+===========+=========================== */


/* ================================+======================================= */
/* RA (D1-D8)					   |   	TBBS (A4(1)-(8))					*/
/* ---------------------+----------+-----------+--------------------------- */
/* If Flag ON    	|Flag OFF  |If Flag ON | IF Flag OFF                */
/* ---------------------+----------+-----------+--------------------------- */
/* D1           	|          |           |                         	*/
/* D2			|	   |	       |							*/
/* D3                 	|          |	       |							*/
/* D4                   |          |	       |							*/
/* D5                   |          |	       |							*/
/* D6			|	   |	       |							*/
/* D7			|	   |	       |							*/
/* D8                   |	   |	       |							*/
/* =====================+==========+===========+=========================== */



/* 61   : Terminal Nulls needed	(1 byte)								*/
/*																		*/

	tusers.termnulls = 0;

/* 62   : Configuration Flags (1 byte)									*/
/*			Bit 7 : Reserved                                            */
/*			Bit	6 : line Feeds                                          */
/*			Bit 5 : Reserved                                            */
/*			Bit 4 : Reserved                                            */
/*			Bit 3 : Upper Case allowed                                  */
/*			Bit 2 : Reserved                                            */
/*			Bit 1 : ANSI allowed                                        */
/*			Bit 0 : 8 bit IBM graphics allowed							*/
/*																		*/

	tusers.configflags =   0
						+ 64 * 1
						+  0
						+  0
						+  8 * 0
						+  0
						+  2 * (users.attribute & 8)/8
						+  1 * (users.attribute & 8)/8;

/* 63   : Terminal Width   (1 byte)										*/
/*																		*/
	if (users.screenwidth == 0)
		tusers.termcolwidth = 80;
	else
		tusers.termcolwidth = users.screenwidth;



/* 64-66: Screen Clear codes (3 bytes)									*/
/*																		*/
/*		 IBM Plain		12 00 00 00 00 00    							*/
/*		 ANSI/VT-100	27 91 72 27 91 74								*/
/*		 Generic    	13 13 00 00 00 00								*/
/*																		*/
		tusers.clscodes_a[0] = 13 + (27-13)*(users.attribute & 8)/8;
		tusers.clscodes_a[1] = 13 + (91-13)*(users.attribute & 8)/8;
		tusers.clscodes_a[2] =  0 + 72*(users.attribute & 8)/8;


/* 67   : Total # of log ons (2 bytes)									*/
/*																		*/
	tusers.logons = users.nocalls;


/* 69   : User Expert level (1 byte)   									*/
/*																		*/
	tusers.expertlevel=0;


/* 70   : Number of Last Message Read (system wide, 2 bytes)				*/
/*																		*/
	tusers.lastmsgread = 0;


/* 72   : Review flags (1byte)         									*/
/*			Bit 7 : Reserved                                            */
/*			Bit	6 : Marked for Deletion                                 */
/*			Bit 5 : "Keep" protected                                    */
/*			Bit 4 : Reviewed by sysop                                   */
/*			Bit 3 : Has read "news" file once          					*/
/*			Bit 2 : Allowed to netmail without credit balance           */
/*			Bit 1 : Allowed to originate Crash Netmail					*/
/*			Bit 0 : "Full Access" allowed regardless of A3 bump flag match */
/*																		*/
	tusers.reviewflags =   0
						+ 64 * (users.attribute & 1)
						+ 32 * (users.attribute & 16)/16
						+ 16 * 0
						+  8 * 0
						+  4 * (users.security >= 20)
						+  2 * (users.security >= 40)
						+  1 * (users.security >= 30);


/* 73   : Per call time limit (1 byte) 									*/
/*																		*/

        switch(tusers.userspriv) {
           case   0:
           case   1:
           case   2:
           case   3:
           case   4:   tusers.percalltimelimit = 20;  break;
           case   5:
           case   7:
           case  10:   tusers.percalltimelimit = 30;  break;
           case  20:
           case  21:
           case  24:
	   case  30:   tusers.percalltimelimit = 60;  break;
	   case  40:
	   case  50:
	   case  60:   tusers.percalltimelimit = 90;  break;
           case 100:
	   case 200:
           case 254:
	   case 255:   tusers.percalltimelimit = 0; break; };


/* 74   : Last 10 logons, 5 bytes per entry Mth, Day, Yr, Hr, Min		*/
/*																		*/
i=0;
do {
			tusers.last10logons[i].Mo  = 0;
			tusers.last10logons[i].Day = 0;
			tusers.last10logons[i].Yr  = 0;
			tusers.last10logons[i].Hr  = 0;
			tusers.last10logons[i].Min = 0;
			i= i + 1; }
while (i<9);

		if (users.lastdate.l1 > 0) {
			tusers.last10logons[0].Mo  = 10*(users.lastdate.Date[0]-48)+ (users.lastdate.Date[1]-48);
			tusers.last10logons[0].Day = 10*(users.lastdate.Date[3]-48)+ (users.lastdate.Date[4]-48);
			tusers.last10logons[0].Yr  = 10*(users.lastdate.Date[6]-48)+ (users.lastdate.Date[7]-48); };

		if (users.lasttime.l1 > 0) {
			tusers.last10logons[0].Hr  = 10*(users.lasttime.Time[0]-48)+ (users.lasttime.Time[1]-48);;
			tusers.last10logons[0].Min = 10*(users.lasttime.Time[3]-48)+ (users.lasttime.Time[4]-48);};


/* 124  : SYSFGS for board 1-32 (left to right from bit 7 of byte 124)  	*/
/*																	   		*/

			tusers.SYSFGS1[0] =0;
			tusers.SYSFGS1[1] =0;
			tusers.SYSFGS1[2] =0;
			tusers.SYSFGS1[3] =0;


/* 124-125 : (sysop record only) 124-125 Caller Number of Last Sysop logon	*/
/*																	   		*/
/* 159-160 : number of next caller 											*/
/*																	   		*/
/* 126-127 : number of next caller 											*/
/*																	   		*/


/* 128		: User's A3 flags  (1 byte)										*/
/*																		*/
	tusers.A3 = 0;


/* 129		: User's A4 flags  (1 byte)										*/
/*																		*/
	tusers.A4 = 0;


/* 130-132	: Screen Clear codes (last 3 bytes)						   		*/
/*																		*/
		tusers.clscodes_b[0] = 27 * (users.attribute & 8)/8;
		tusers.clscodes_b[1] = 91 * (users.attribute & 8)/8;
		tusers.clscodes_b[2] = 74 * (users.attribute & 8)/8;


/* 133    	: Msg Waiting Chain Head (msg # format, Motoroal fwd order)	*/
/*																		*/
		tusers.msgwaitchainhead = 0;


/* 135-138	: Total bytes downloaded (Intel long format)               	*/
/*																		*/
		tusers.totaldlbytes = users.downloadsk*1024;


/* 139-142	: Total bytes uploaded (Intel long format)               	*/
/*																		*/
        if  (users.uploads == 1)
           tusers.totalulbytes = 0;
        else
           tusers.totalulbytes = max(0,(users.uploadsk*1024-100000));


/* 143-146	: Download per day limit (Intel long format)               	*/
/*																		*/

        switch(tusers.userspriv) {
           case   0:
           case   1:
           case   2:
           case   3:
           case   4:   tusers.dlbytesperday = 100000;   break;
           case   5:
           case   7:
           case  10:   tusers.dlbytesperday = 500000;   break;
           case  20:
           case  21:
           case  24:
           case  27:   tusers.dlbytesperday = 10000000; break;
           case  30:
           case  40:
           case  50:
	   case  60:   tusers.dlbytesperday = 30000000; break;
	   case 100:
	   case 200:
	   case 254:
	   case 255:   tusers.dlbytesperday = 0; break; };


/* 147    	: Calls per day limit (1 byte)                             	*/
/*																		*/


        switch(tusers.userspriv) {
           case   0:
           case   1:
           case   2:
           case   3:
	   case   4:   tusers.calls_day =  5; break;
	   case   5:
           case   7:
	   case  10:   tusers.calls_day =  5; break;
	   case  20:
	   case  21:
	   case  24:
	   case  27:
	   case  30:   tusers.calls_day = 10; break;
	   case  40:
	   case  50:
	   case  60:   tusers.calls_day = 20; break;
	   case 100:
	   case 200:
	   case 254:
	   case 255:   tusers.calls_day = 0; break; };

/* 148    	: calls made in the last day (1 byte)                      	*/
/*																		*/
// RA does not seem to record the number of calls today, only the date of
// the last call and the time.  Could add test here to see if this last call
// was made today, and make = 1 if it was. I am leaving it set to 0.

		tusers.calls_last = 0;


/* 149    	: Minutes per day limit (2 bytes)                          	*/
/*																		*/
        switch(tusers.userspriv) {
           case   0:
           case   1:
           case   2:
           case   3:
           case   4:   tusers.mins_day = 20;     break;
           case   5:
           case   7:
           case  10:   tusers.mins_day = 30;     break;
           case  20:
           case  21:
           case  24:
           case  30:
           case  40:
           case  50:
           case  60:   tusers.mins_day = 60; break;
           case 100:
	   case 200:
           case 254:
	   case 255:   tusers.mins_day = 0; break; };


/* 151-2  	: Minutes made in the last day (2 bytes)                   	*/
/*																		*/
		tusers.mins_last = users.elapsed;

/* 153-5 :  Billing Class 0 Time limit (3 bytes)						*/
/*																		*/

		tusers.bclass0limit.hours = 0;
		tusers.bclass0limit.mins = 0;


/* 159-161  :  SYSFGS for Boards 33-56 (3 bytes)						*/
/*																		*/
		tusers.SYSFGS33[0] =0;
		tusers.SYSFGS33[1] =0;
		tusers.SYSFGS33[2] =0;


/* 162-4 :  Billing Class 0 Time remaining (3 bytes)					*/
/*																		*/

		tusers.bclass0left.hours = 0;
		tusers.bclass0left.mins = 0;

/* 165-8 :  Bytes downloaded in the last day (Intel long fmt, 4 bytes)  */
/*																		*/

		tusers.dl_last = users.todayk*1024;


/* 169   :  -More- lines per page, (0=none, valid 10-80) (1 byte)       */
/*																		*/

if ( users.attribute && 4)
	tusers.morelines = users.screenlength;
else
	tusers.morelines = 0;


/* 170  :  Notes (64 characters, null terminated)						*/
//
// TBBS has a 64 character notes field, RA has an 80 character comments field
//
// With the CHECKPWD.TPG TDBS application, the last 8 bytes are being used
// for a hexadecimal copy of the 4 byte RA password CRC.
//
// Otherwise this section can be customised to some extent:
//
// 0        1         2         3         4         5         6
// 1234567890123456789012345678901234567890123456789012345678901234
// GMM/DD/YYxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxRAPWDCRC
//          <------------ part of RA comments field------->
//
// byte   1    Gender/sex of user. M=male, F=female, ?=unknown
// bytes  2-9  Birthdate MM/DD/YY
// bytes 10-56 First 46 bytes from RA comments
// bytes 57-64 8 byte ascii copy of RA password CRC in Hexadecimal

	strcpy(tusers.notes,blanks);

	switch (users.sex) {
		case 0:  tusers.notes[0] = '?'; break;
		case 1:  tusers.notes[0] = 'M'; break;
		case 2:  tusers.notes[0] = 'F'; break;
		default: tusers.notes[0] = '?';
	};

        i = -1;

        do {
	   i = i+1;
	   tusers.notes[1+i] = users.birthdate.Date[i];
	} while (i < users.birthdate.l1+1);
	tusers.notes[3] = '/';
	tusers.notes[6] = '/';

	strncpy(tempnote,users.comment,45);
	tempnote[users.l7]= '\0';

	i = 0;
    flag0 = 0;
	do {
        if (tempnote[i] == 0) flag0 = 32;
	    if  (flag0 == 32)
          tusers.notes[9+i] = 32;
        else
          tusers.notes[9+i] = tempnote[i];
	    i = i+1;
	} while (i<45);

	sprintf(password,"%08lX",users.passwordcrc);

	i = 0;

        do {
	   tusers.notes[54+i] = password[i];
	   i = i+1;
	} while (i<8);

    tusers.notes[63]='\0';

/* 234  :  Netmail Credits  - cents (2 bytes)    						*/
/*																		*/
		tusers.netmailcredits = 0;


/* 236  :  Netmail Debits  - cents (2 bytes)    						*/
/*																		*/
		tusers.netmaildebits = 0;


/* 238  :  Special Flags - (1byte)              						*/
/*			Bit 7   : "Invisible" User                                  */
/*			Bit	6-0 : Reserved                                          */

		tusers.specialflg1 = 128 * (users.Attribute2 & 8)/8;


/* 239  :  Upload protocol   (1 byte) 									*/
/*																		*/
        switch(users.defaultprot) {
           case 'X': tusers.ulprot =  4 ; break;
           case '1': tusers.ulprot =  5 ; break;
           case 'Y': tusers.ulprot =  6 ; break;
           case 'G': tusers.ulprot =  7 ; break;
           case 'Z': tusers.ulprot = 11 ; break;
           default : tusers.ulprot =  0 ; };



/* 240  :  Download protocol   (1 byte) 								*/
/*																		*/
        switch(users.defaultprot) {
           case 'X': tusers.dlprot =  4 ; break;
           case '1': tusers.dlprot =  5 ; break;
           case 'Y': tusers.dlprot =  6 ; break;
           case 'G': tusers.dlprot =  7 ; break;
           case 'Z': tusers.dlprot = 11 ; break;
           default : tusers.dlprot =  0 ; };

/* 241  :  SYSFGS for Boards 57-64 (1 byte)								*/
/*																		*/
		tusers.SYSFGS57 = 0;


/* 242  :  Message System Flags (1 byte)								   */
/*			Bit 7   : Don't prompt for Prepared Text                       */
/*			Bit	6-5 : FSE mode (0=ask, 1=yes, 2=no)                        */
/*			Bit 4   : Last Message Read Pointer (0=highest, 1=no holes)    */
/*			Bit	3-2 : Reserved (always 0)                                  */
/*			Bit	1-0 : Prompt style (0=line #, 1=bytes/line, 2 prompt only) */

		tusers.msgflags = 128 * 0
        				+  64 * 0
						+  32 * 0
						+  16 * 0
						+   8 * 0
						+   4 * 0
						+   2 * 0
						+   1 * 0;


/* 243  :  Date password was last changed (mm,dd,yy) 3 bytes			    */
/*																		    */

		tusers.lastpwdchg.mm = 0;
		tusers.lastpwdchg.dd = 0;
		tusers.lastpwdchg.yy = 0;


/* 246  :  Special Flags (1 byte)     										*/
/*        	    Bit 7-2 : Reserved (always 0)                               */
/*				Bit	1   : Password Expired (true=expired)					*/
/*				Bit	0   : Result of Logon ANSI Poll (true=ANSI detected)	*/

		tusers.specialflg2 =  2 * 0
							+ 1 * 0;


/* 247-9 : Reserved (3 bytes, always 0)                              		*/
/*																		    */

		tusers.reserved1[1] = 0;
		tusers.reserved1[2] = 0;
		tusers.reserved1[3] = 0;


/* 250-1 : Number of Cubbyholed messages "aged" out  by MFSQZ (2 bytes)		*/
/*																		    */

		tusers.cbymsgsaged = 0;


/* 252   : Pointer to USERLOG.PTR Chain (0=none, Intel long format) 		*/
/*																		    */

		tusers.ptr2userlog = 0;


/* 256-383 : Address 1, 2, City, State, Zip, Phone & Country          		*/
/*   	     strings are variable in length, null terminated, total			*/
/*           stored length without nulls = 121 (128 bytes total)			*/


i=0;
do {
	tusers.address[i] = '\0';
	i=i+1; }
while (i<128);

ADDR1[0]   = ' ';
ADDR1[1]   = '\0';
ADDR2[0]   = ' ';
ADDR2[1]   = '\0';
CITY[0]    = ' ';
CITY[1]    = '\0';
STATE[0]   = ' ';
STATE[1]   = '\0';
ZIP[0]     = ' ';
ZIP[1]     = '\0';
PHONE[0]   = ' ';
PHONE[1]   = '\0';
COUNTRY[0] = ' ';
COUNTRY[1] = '\0';



strcpy(PHONE,users.voicephone);

t[0] = '\0';
strcat(t,users.address1);
strcat(t,users.address2);
strcat(t,users.address3);

i=0;


i=   strlen(ADDR1) + strlen(ADDR2) + strlen(CITY)
   + strlen(STATE) + strlen(ZIP) + strlen(COUNTRY) + strlen(PHONE);

if (i <= 121) {

  i = 0;
  j = 0;

  do {
		tusers.address[i] = ADDR1[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(ADDR1));
  tusers.address[i]='\0';

  i=i+1;
  j = 0;

  do {
		tusers.address[i] = ADDR2[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(ADDR2));
  tusers.address[i]='\0';
  i=i+1;
  j = 0;
  do {
		tusers.address[i] = CITY[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(CITY));
  tusers.address[i]='\0';

  i=i+1;
  j = 0;

  do {
		tusers.address[i] = STATE[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(STATE));
  tusers.address[i]='\0';

  i=i+1;
  j = 0;

  do {
		tusers.address[i] = ZIP[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(ZIP));
  tusers.address[i]='\0';

  i=i+1;
  j = 0;

  do {
		tusers.address[i] = PHONE[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(PHONE));
  tusers.address[i]='\0';

  i=i+1;
  j = 0;

  do {
		tusers.address[i] = COUNTRY[j];
		j=j+1;
		i=i+1; }
  while (j<strlen(COUNTRY));
  tusers.address[i]='\0'; }

else
	printf ("address for %s is too long, %i\n", tusers.name_locn,i);



/* 384-5 : Reserved (2 bytes, always 0)                               		*/
/*																		    */

	tusers.reserved2[0] = 0;
	tusers.reserved2[1] = 0;


/* 386-439 : Billing Class (1-9) time limits hrs (2 bytes) mins (1 byte)	*/
/*																		    */

i = 0;

do {
	tusers.billingclass[i].limithours = 0;
	tusers.billingclass[i].limitmins  = 0;

	tusers.billingclass[i].connecthours = 0;
	tusers.billingclass[i].connectmins  = 0;

	i = i+1; }

while (i<9);


/* 440-442 : Expiration date (mm, dd, yy)									*/
/*																		    */

if ((users.subdate.Date[0] == ' ') | (users.security >= 30) | (strlen(users.subdate.Date) == 0) )
   { tusers.expiration.mm = 0;
	 tusers.expiration.dd = 0;
	 tusers.expiration.yy = 0; }
else
   { tusers.expiration.mm = 10*(users.subdate.Date[0]-48)+ (users.subdate.Date[1]-48);
	 tusers.expiration.dd = 10*(users.subdate.Date[3]-48)+ (users.subdate.Date[4]-48);
	 tusers.expiration.yy = 10*(users.subdate.Date[6]-48)+ (users.subdate.Date[7]-48); };


/* 443-511 : Reserved (always 0, 69 bytes)                               	*/
/*																		    */

i = 0;

do {

	tusers.reserved3[i] = 0;

	i = i+1; }

while (i<69);

};




// *************************************************************************
//
// MAIN PROGRAM .......
//
// from here we read the records from the old RA userbase, user by user, and
// run them through the map procedure then write to the new TBBS userbase.
//
//
// *************************************************************************



void main()
{
	int x;

	char *ra_env;
	char path[40];

	FILE *RA_USERS;
	FILE *RA_CONF;
	FILE *TBBS_USERS;

	clrscr();

    printf("RA ver 2.x to TBBS User base conversion utility, test version 0.92 07-Feb-96\n");
    printf("Copyright (c) Robert Dyball, 1996  email: bob.dyball@dse.mpx.com.au \n\n");

    printf("ͻ\n");
    printf(" Converting record #                                                  \n");
    printf("ͼ\n");

	ra_env = getenv("RA");
// printf("ra_env %s\n",ra_env);
	path[0] = '\0';
	strcat(path,ra_env);
// printf("path %s\n",path);
	strcat(path,"\\config.ra");
// printf("path %s\n",path);

	if ((RA_CONF = fopen(path, "rb")) == NULL) {
		printf("Error opening Remote Access CONFIG.RA file for reading\n");
		exit(0);
	};

	fscanf(RA_CONF, "%6331c", &config);
	fclose(RA_CONF);

	path[0] = '\0';
	strncat(path,config.MsgBasePath,config.l20);
	strcat(path,"users.bbs");
	printf("Path to CONFIG.RA = %s\n",path);

	if ((RA_USERS = fopen(path, "rb")) == NULL) {
		printf("Error opening RA USERS.BBS file for reading\n");
		exit(0);
	};

	if ((TBBS_USERS = fopen("c:\\tbbs\\userlog.bbs", "r+b")) == NULL) {
		printf("Error opening TBBS USERLOG.BBS file for reading\n");
		exit(0);
	};

	x = 0;

	do {
		x = x+1;

		fscanf(RA_USERS, "%1016c", &users);

	if (!feof(RA_USERS)) {

		/*	d_rauser();
		scanf(TBBS_USERS, "%512c", &tusers);
		d_tbbsuser();  */

		map_RA2TBBS();

        gotoxy(25,5);

		printf("%05d  %-35s", x, tusers.name_locn);

		fwrite(&tusers,512,1,TBBS_USERS); };


/*	} while (x<20); */

	} while (!feof(RA_USERS));

   fclose(RA_USERS);
   fclose(TBBS_USERS);

   gotoxy(1,9);
   printf ("Conversion of users from Remote Access to TBBS completed.\n\n");

}

